unit schComisionesClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Facturas_Comision = '{EA4A0704-B8AD-4632-9FF0-D51D52FF60B6}';
  RID_DarReferencia = '{579724B6-8389-482A-B4A4-EEEA864CAEA0}';
  RID_Comisiones = '{1D36BBB6-821F-4450-8855-482C4E797FFE}';
  RID_Comisiones_Refresh = '{FEB4830C-01B3-4B40-BA7A-CE3D8AF44596}';
  RID_V_Detalles_Facturas_Comision = '{69E506D8-A8D4-4D90-8D3F-61BBF29BBD60}';

  { Data table names }
  nme_Facturas_Comision = 'Facturas_Comision';
  nme_DarReferencia = 'DarReferencia';
  nme_Comisiones = 'Comisiones';
  nme_Comisiones_Refresh = 'Comisiones_Refresh';
  nme_V_Detalles_Facturas_Comision = 'V_Detalles_Facturas_Comision';

  { Facturas_Comision fields }
  fld_Facturas_ComisionID_EMPRESA = 'ID_EMPRESA';
  fld_Facturas_ComisionID_AGENTE = 'ID_AGENTE';
  fld_Facturas_ComisionAGENTE = 'AGENTE';
  fld_Facturas_ComisionID_FACTURA = 'ID_FACTURA';
  fld_Facturas_ComisionID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_Facturas_ComisionFECHA = 'FECHA';
  fld_Facturas_ComisionREFERENCIA = 'REFERENCIA';
  fld_Facturas_ComisionSITUACION = 'SITUACION';
  fld_Facturas_ComisionID_CLIENTE = 'ID_CLIENTE';
  fld_Facturas_ComisionCLIENTE = 'CLIENTE';
  fld_Facturas_ComisionID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_Facturas_ComisionPROVEEDOR = 'PROVEEDOR';
  fld_Facturas_ComisionCOMISION = 'COMISION';
  fld_Facturas_ComisionIMPORTE_COMISIONABLE = 'IMPORTE_COMISIONABLE';
  fld_Facturas_ComisionIMPORTE_COMISION = 'IMPORTE_COMISION';

  { Facturas_Comision field indexes }
  idx_Facturas_ComisionID_EMPRESA = 0;
  idx_Facturas_ComisionID_AGENTE = 1;
  idx_Facturas_ComisionAGENTE = 2;
  idx_Facturas_ComisionID_FACTURA = 3;
  idx_Facturas_ComisionID_COMISION_LIQUIDADA = 4;
  idx_Facturas_ComisionFECHA = 5;
  idx_Facturas_ComisionREFERENCIA = 6;
  idx_Facturas_ComisionSITUACION = 7;
  idx_Facturas_ComisionID_CLIENTE = 8;
  idx_Facturas_ComisionCLIENTE = 9;
  idx_Facturas_ComisionID_PROVEEDOR = 10;
  idx_Facturas_ComisionPROVEEDOR = 11;
  idx_Facturas_ComisionCOMISION = 12;
  idx_Facturas_ComisionIMPORTE_COMISIONABLE = 13;
  idx_Facturas_ComisionIMPORTE_COMISION = 14;

  { DarReferencia fields }
  fld_DarReferenciaVALOR = 'VALOR';

  { DarReferencia field indexes }
  idx_DarReferenciaVALOR = 0;

  { Comisiones fields }
  fld_ComisionesID = 'ID';
  fld_ComisionesID_EMPRESA = 'ID_EMPRESA';
  fld_ComisionesREFERENCIA = 'REFERENCIA';
  fld_ComisionesID_AGENTE = 'ID_AGENTE';
  fld_ComisionesDESCRIPCION = 'DESCRIPCION';
  fld_ComisionesFECHA = 'FECHA';
  fld_ComisionesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_ComisionesUSUARIO = 'USUARIO';
  fld_ComisionesNOMBRE = 'NOMBRE';

  { Comisiones field indexes }
  idx_ComisionesID = 0;
  idx_ComisionesID_EMPRESA = 1;
  idx_ComisionesREFERENCIA = 2;
  idx_ComisionesID_AGENTE = 3;
  idx_ComisionesDESCRIPCION = 4;
  idx_ComisionesFECHA = 5;
  idx_ComisionesIMPORTE_TOTAL = 6;
  idx_ComisionesUSUARIO = 7;
  idx_ComisionesNOMBRE = 8;

  { Comisiones_Refresh fields }
  fld_Comisiones_RefreshID = 'ID';
  fld_Comisiones_RefreshID_EMPRESA = 'ID_EMPRESA';
  fld_Comisiones_RefreshREFERENCIA = 'REFERENCIA';
  fld_Comisiones_RefreshID_AGENTE = 'ID_AGENTE';
  fld_Comisiones_RefreshDESCRIPCION = 'DESCRIPCION';
  fld_Comisiones_RefreshFECHA = 'FECHA';
  fld_Comisiones_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_Comisiones_RefreshUSUARIO = 'USUARIO';
  fld_Comisiones_RefreshNOMBRE = 'NOMBRE';

  { Comisiones_Refresh field indexes }
  idx_Comisiones_RefreshID = 0;
  idx_Comisiones_RefreshID_EMPRESA = 1;
  idx_Comisiones_RefreshREFERENCIA = 2;
  idx_Comisiones_RefreshID_AGENTE = 3;
  idx_Comisiones_RefreshDESCRIPCION = 4;
  idx_Comisiones_RefreshFECHA = 5;
  idx_Comisiones_RefreshIMPORTE_TOTAL = 6;
  idx_Comisiones_RefreshUSUARIO = 7;
  idx_Comisiones_RefreshNOMBRE = 8;

  { V_Detalles_Facturas_Comision fields }
  fld_V_Detalles_Facturas_ComisionID_EMPRESA = 'ID_EMPRESA';
  fld_V_Detalles_Facturas_ComisionID_AGENTE = 'ID_AGENTE';
  fld_V_Detalles_Facturas_ComisionAGENTE = 'AGENTE';
  fld_V_Detalles_Facturas_ComisionID_FACTURA = 'ID_FACTURA';
  fld_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_V_Detalles_Facturas_ComisionFECHA = 'FECHA';
  fld_V_Detalles_Facturas_ComisionREFERENCIA = 'REFERENCIA';
  fld_V_Detalles_Facturas_ComisionSITUACION = 'SITUACION';
  fld_V_Detalles_Facturas_ComisionID_CLIENTE = 'ID_CLIENTE';
  fld_V_Detalles_Facturas_ComisionCLIENTE = 'CLIENTE';
  fld_V_Detalles_Facturas_ComisionID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_V_Detalles_Facturas_ComisionPROVEEDOR = 'PROVEEDOR';
  fld_V_Detalles_Facturas_ComisionCOMISION = 'COMISION';
  fld_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE = 'IMPORTE_COMISIONABLE';
  fld_V_Detalles_Facturas_ComisionIMPORTE_COMISION = 'IMPORTE_COMISION';

  { V_Detalles_Facturas_Comision field indexes }
  idx_V_Detalles_Facturas_ComisionID_EMPRESA = 0;
  idx_V_Detalles_Facturas_ComisionID_AGENTE = 1;
  idx_V_Detalles_Facturas_ComisionAGENTE = 2;
  idx_V_Detalles_Facturas_ComisionID_FACTURA = 3;
  idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA = 4;
  idx_V_Detalles_Facturas_ComisionFECHA = 5;
  idx_V_Detalles_Facturas_ComisionREFERENCIA = 6;
  idx_V_Detalles_Facturas_ComisionSITUACION = 7;
  idx_V_Detalles_Facturas_ComisionID_CLIENTE = 8;
  idx_V_Detalles_Facturas_ComisionCLIENTE = 9;
  idx_V_Detalles_Facturas_ComisionID_PROVEEDOR = 10;
  idx_V_Detalles_Facturas_ComisionPROVEEDOR = 11;
  idx_V_Detalles_Facturas_ComisionCOMISION = 12;
  idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE = 13;
  idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION = 14;

type
  { IFacturas_Comision }
  IFacturas_Comision = interface(IDAStronglyTypedDataTable)
  ['{3C7E800C-733C-4AD2-88B0-1FB0C30EEAB4}']
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetAGENTEValue: String;
    procedure SetAGENTEValue(const aValue: String);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetCLIENTEValue: String;
    procedure SetCLIENTEValue(const aValue: String);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetPROVEEDORValue: String;
    procedure SetPROVEEDORValue(const aValue: String);
    function GetCOMISIONValue: Float;
    procedure SetCOMISIONValue(const aValue: Float);
    function GetIMPORTE_COMISIONABLEValue: Currency;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
    function GetIMPORTE_COMISIONValue: Currency;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency);


    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;
  end;

  { TFacturas_ComisionDataTableRules }
  TFacturas_ComisionDataTableRules = class(TDADataTableRules, IFacturas_Comision)
  private
  protected
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetAGENTEValue: String; virtual;
    procedure SetAGENTEValue(const aValue: String); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetCLIENTEValue: String; virtual;
    procedure SetCLIENTEValue(const aValue: String); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetPROVEEDORValue: String; virtual;
    procedure SetPROVEEDORValue(const aValue: String); virtual;
    function GetCOMISIONValue: Float; virtual;
    procedure SetCOMISIONValue(const aValue: Float); virtual;
    function GetIMPORTE_COMISIONABLEValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency); virtual;
    function GetIMPORTE_COMISIONValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency); virtual;

    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IDarReferencia }
  IDarReferencia = interface(IDAStronglyTypedDataTable)
  ['{6F6CF728-FD82-4921-95BA-666E4F70B3C2}']
    { Property getters and setters }
    function GetVALORValue: String;
    procedure SetVALORValue(const aValue: String);


    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;
  end;

  { TDarReferenciaDataTableRules }
  TDarReferenciaDataTableRules = class(TDADataTableRules, IDarReferencia)
  private
  protected
    { Property getters and setters }
    function GetVALORValue: String; virtual;
    procedure SetVALORValue(const aValue: String); virtual;

    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IComisiones }
  IComisiones = interface(IDAStronglyTypedDataTable)
  ['{72F0B3AD-C3B5-40E7-8135-300E67F02488}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetIMPORTE_TOTALValue: Float;
    procedure SetIMPORTE_TOTALValue(const aValue: Float);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
  end;

  { TComisionesDataTableRules }
  TComisionesDataTableRules = class(TDADataTableRules, IComisiones)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetIMPORTE_TOTALValue: Float; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Float); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IComisiones_Refresh }
  IComisiones_Refresh = interface(IDAStronglyTypedDataTable)
  ['{55229695-D8C9-42DD-AF4A-98A105CB3AB5}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetIMPORTE_TOTALValue: Float;
    procedure SetIMPORTE_TOTALValue(const aValue: Float);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
  end;

  { TComisiones_RefreshDataTableRules }
  TComisiones_RefreshDataTableRules = class(TDADataTableRules, IComisiones_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetIMPORTE_TOTALValue: Float; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Float); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IV_Detalles_Facturas_Comision }
  IV_Detalles_Facturas_Comision = interface(IDAStronglyTypedDataTable)
  ['{9B3F1419-AEA0-494C-A072-DD93052AC2E4}']
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetAGENTEValue: String;
    procedure SetAGENTEValue(const aValue: String);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetCLIENTEValue: String;
    procedure SetCLIENTEValue(const aValue: String);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetPROVEEDORValue: String;
    procedure SetPROVEEDORValue(const aValue: String);
    function GetCOMISIONValue: Float;
    procedure SetCOMISIONValue(const aValue: Float);
    function GetIMPORTE_COMISIONABLEValue: Currency;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
    function GetIMPORTE_COMISIONValue: Currency;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency);


    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;
  end;

  { TV_Detalles_Facturas_ComisionDataTableRules }
  TV_Detalles_Facturas_ComisionDataTableRules = class(TDADataTableRules, IV_Detalles_Facturas_Comision)
  private
  protected
    { Property getters and setters }
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetAGENTEValue: String; virtual;
    procedure SetAGENTEValue(const aValue: String); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetCLIENTEValue: String; virtual;
    procedure SetCLIENTEValue(const aValue: String); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetPROVEEDORValue: String; virtual;
    procedure SetPROVEEDORValue(const aValue: String); virtual;
    function GetCOMISIONValue: Float; virtual;
    procedure SetCOMISIONValue(const aValue: Float); virtual;
    function GetIMPORTE_COMISIONABLEValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONABLEValue(const aValue: Currency); virtual;
    function GetIMPORTE_COMISIONValue: Currency; virtual;
    procedure SetIMPORTE_COMISIONValue(const aValue: Currency); virtual;

    { Properties }
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property AGENTE: String read GetAGENTEValue write SetAGENTEValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property CLIENTE: String read GetCLIENTEValue write SetCLIENTEValue;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property PROVEEDOR: String read GetPROVEEDORValue write SetPROVEEDORValue;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property IMPORTE_COMISIONABLE: Currency read GetIMPORTE_COMISIONABLEValue write SetIMPORTE_COMISIONABLEValue;
    property IMPORTE_COMISION: Currency read GetIMPORTE_COMISIONValue write SetIMPORTE_COMISIONValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TFacturas_ComisionDataTableRules }
constructor TFacturas_ComisionDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturas_ComisionDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturas_ComisionDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetAGENTEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionAGENTE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetAGENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionAGENTE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_FACTURA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_FACTURA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA].AsDateTime;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Facturas_ComisionFECHA].AsDateTime := aValue;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSITUACION].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionSITUACION].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetCLIENTEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCLIENTE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetCLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionCLIENTE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_PROVEEDOR].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_PROVEEDOR].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetPROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPROVEEDOR].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetPROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionPROVEEDOR].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetCOMISIONValue: Float;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCOMISION].AsFloat;
end;

procedure TFacturas_ComisionDataTableRules.SetCOMISIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_Facturas_ComisionCOMISION].AsFloat := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_COMISIONABLEValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_COMISIONValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISION].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_COMISIONValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_COMISION].AsCurrency := aValue;
end;


{ TDarReferenciaDataTableRules }
constructor TDarReferenciaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDarReferenciaDataTableRules.Destroy;
begin
  inherited;
end;

function TDarReferenciaDataTableRules.GetVALORValue: String;
begin
  result := DataTable.Fields[idx_DarReferenciaVALOR].AsString;
end;

procedure TDarReferenciaDataTableRules.SetVALORValue(const aValue: String);
begin
  DataTable.Fields[idx_DarReferenciaVALOR].AsString := aValue;
end;


{ TComisionesDataTableRules }
constructor TComisionesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TComisionesDataTableRules.Destroy;
begin
  inherited;
end;

function TComisionesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID].AsInteger;
end;

procedure TComisionesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID_EMPRESA].AsInteger;
end;

procedure TComisionesDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID_EMPRESA].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_ComisionesREFERENCIA].AsString;
end;

procedure TComisionesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesREFERENCIA].AsString := aValue;
end;

function TComisionesDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID_AGENTE].AsInteger;
end;

procedure TComisionesDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID_AGENTE].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_ComisionesDESCRIPCION].AsString;
end;

procedure TComisionesDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesDESCRIPCION].AsString := aValue;
end;

function TComisionesDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_ComisionesFECHA].AsDateTime;
end;

procedure TComisionesDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ComisionesFECHA].AsDateTime := aValue;
end;

function TComisionesDataTableRules.GetIMPORTE_TOTALValue: Float;
begin
  result := DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsFloat;
end;

procedure TComisionesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Float);
begin
  DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsFloat := aValue;
end;

function TComisionesDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_ComisionesUSUARIO].AsString;
end;

procedure TComisionesDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesUSUARIO].AsString := aValue;
end;

function TComisionesDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_ComisionesNOMBRE].AsString;
end;

procedure TComisionesDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesNOMBRE].AsString := aValue;
end;


{ TComisiones_RefreshDataTableRules }
constructor TComisiones_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TComisiones_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TComisiones_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshID].AsInteger;
end;

procedure TComisiones_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Comisiones_RefreshID].AsInteger := aValue;
end;

function TComisiones_RefreshDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshID_EMPRESA].AsInteger;
end;

procedure TComisiones_RefreshDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Comisiones_RefreshID_EMPRESA].AsInteger := aValue;
end;

function TComisiones_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshREFERENCIA].AsString;
end;

procedure TComisiones_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_Comisiones_RefreshREFERENCIA].AsString := aValue;
end;

function TComisiones_RefreshDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshID_AGENTE].AsInteger;
end;

procedure TComisiones_RefreshDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Comisiones_RefreshID_AGENTE].AsInteger := aValue;
end;

function TComisiones_RefreshDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshDESCRIPCION].AsString;
end;

procedure TComisiones_RefreshDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Comisiones_RefreshDESCRIPCION].AsString := aValue;
end;

function TComisiones_RefreshDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshFECHA].AsDateTime;
end;

procedure TComisiones_RefreshDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Comisiones_RefreshFECHA].AsDateTime := aValue;
end;

function TComisiones_RefreshDataTableRules.GetIMPORTE_TOTALValue: Float;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshIMPORTE_TOTAL].AsFloat;
end;

procedure TComisiones_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Float);
begin
  DataTable.Fields[idx_Comisiones_RefreshIMPORTE_TOTAL].AsFloat := aValue;
end;

function TComisiones_RefreshDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshUSUARIO].AsString;
end;

procedure TComisiones_RefreshDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_Comisiones_RefreshUSUARIO].AsString := aValue;
end;

function TComisiones_RefreshDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_Comisiones_RefreshNOMBRE].AsString;
end;

procedure TComisiones_RefreshDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_Comisiones_RefreshNOMBRE].AsString := aValue;
end;


{ TV_Detalles_Facturas_ComisionDataTableRules }
constructor TV_Detalles_Facturas_ComisionDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TV_Detalles_Facturas_ComisionDataTableRules.Destroy;
begin
  inherited;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_EMPRESA].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_EMPRESA].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_AGENTE].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_AGENTE].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetAGENTEValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionAGENTE].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetAGENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionAGENTE].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_FACTURA].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_FACTURA].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionFECHA].AsDateTime;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionFECHA].AsDateTime := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionREFERENCIA].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionREFERENCIA].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionSITUACION].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionSITUACION].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_CLIENTE].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_CLIENTE].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetCLIENTEValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionCLIENTE].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetCLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionCLIENTE].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_PROVEEDOR].AsInteger;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionID_PROVEEDOR].AsInteger := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetPROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionPROVEEDOR].AsString;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetPROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionPROVEEDOR].AsString := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetCOMISIONValue: Float;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionCOMISION].AsFloat;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetCOMISIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionCOMISION].AsFloat := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetIMPORTE_COMISIONABLEValue: Currency;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetIMPORTE_COMISIONABLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISIONABLE].AsCurrency := aValue;
end;

function TV_Detalles_Facturas_ComisionDataTableRules.GetIMPORTE_COMISIONValue: Currency;
begin
  result := DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION].AsCurrency;
end;

procedure TV_Detalles_Facturas_ComisionDataTableRules.SetIMPORTE_COMISIONValue(const aValue: Currency);
begin
  DataTable.Fields[idx_V_Detalles_Facturas_ComisionIMPORTE_COMISION].AsCurrency := aValue;
end;


initialization
  RegisterDataTableRules(RID_Facturas_Comision, TFacturas_ComisionDataTableRules);
  RegisterDataTableRules(RID_DarReferencia, TDarReferenciaDataTableRules);
  RegisterDataTableRules(RID_Comisiones, TComisionesDataTableRules);
  RegisterDataTableRules(RID_Comisiones_Refresh, TComisiones_RefreshDataTableRules);
  RegisterDataTableRules(RID_V_Detalles_Facturas_Comision, TV_Detalles_Facturas_ComisionDataTableRules);

end.
